<?php

declare(strict_types=1);

namespace mirzaev\parser_from_rossko;

use PhpImap\Mailbox as mail,
	PhpImap\Exceptions\ConnectionException as _exception;

ini_set('error_reporting', E_ALL);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

define('INDEX', __DIR__);

// Автозагрузка
require __DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php';

// Инициализация данных аккаунта почты
$account = require(__DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'settings' . DIRECTORY_SEPARATOR . 'account.php');

// Create PhpImap\Mailbox instance for all further actions
$mailbox = new mail(
	$account['imap'], // IMAP server and mailbox folder
	$account['mail'], // Username for the before configured mailbox
	$account['password'], // Password for the before configured username
	__DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'storage' . DIRECTORY_SEPARATOR . 'rossko', // Directory, where attachments will be saved (optional)
	'UTF-8', // Server encoding (optional)
    true, // Trim leading/ending whitespaces of IMAP path (optional)
    true // Attachment filename mode (optional; false = random filename; true = original filename)
);

// set some connection arguments (if appropriate)
$mailbox->setConnectionArgs(
    CL_EXPUNGE // expunge deleted mails upon mailbox close
    //| OP_SECURE // don't do non-secure authentication
);

try {
	// Get all emails (messages)

	// PHP.net imap_search criteria: http://php.net/manual/en/function.imap-search.php
	$mailsIds = $mailbox->searchMailbox('UNSEEN FROM "price@rossko.ru" SINCE "' . date('j F Y', strtotime('-1 day')) . '"');
} catch(_exception $ex) {
	echo "IMAP connection failed: " . implode(",", $ex->getErrors('all'));
	die();
}

// Get the first message (автоматически скачает файл и пометит прочитанным письмо, чтобы не обработать повторно)
if (isset($mailsIds[0])) $mailbox->getMail($mailsIds[0]);
